<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>RecordInputStream (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="RecordInputStream (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":42,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"],32:["t6","Deprecated Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/RecordInputStream.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/hssf/record/RecordFactoryInputStream.html"
               title="class in org.apache.poi.hssf.record"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/hssf/record/RecordInputStream.LeftoverDataException.html"
               title="class in org.apache.poi.hssf.record"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/hssf/record/RecordInputStream.html"
               target="_top">Frames</a></li>
        <li><a href="RecordInputStream.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.hssf.record</div>
    <h2 title="Class RecordInputStream" class="title">Class RecordInputStream</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.hssf.record.RecordInputStream</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd><a href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                           title="interface in org.apache.poi.util">LittleEndianInput</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public final class <span class="typeNameLabel">RecordInputStream</span>
extends java.lang.Object
implements <a href="../../../../../org/apache/poi/util/LittleEndianInput.html" title="interface in org.apache.poi.util">LittleEndianInput</a></pre>
                <div class="block">Title: Record Input Stream

                    Description: Wraps a stream and provides helper methods for the construction of records.
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== NESTED CLASS SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="nested.class.summary">
                        <!--   -->
                    </a>
                        <h3>Nested Class Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Nested Class Summary table, listing nested classes, and an explanation">
                            <caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Class and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.LeftoverDataException.html"
                                        title="class in org.apache.poi.hssf.record">RecordInputStream.LeftoverDataException</a></span></code>
                                    <div class="block">For use in <a
                                            href="../../../../../org/apache/poi/hssf/dev/BiffViewer.html"
                                            title="class in org.apache.poi.hssf.dev"><code>BiffViewer</code></a> which
                                        may construct <a href="../../../../../org/apache/poi/hssf/record/Record.html"
                                                         title="class in org.apache.poi.hssf.record"><code>Record</code></a>s
                                        that don't completely
                                        read all available data.
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#MAX_RECORD_DATA_SIZE">MAX_RECORD_DATA_SIZE</a></span></code>
                                    <div class="block">Maximum size of a single record (minus the 4 byte header) without
                                        a continue
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#RecordInputStream-java.io.InputStream-">RecordInputStream</a></span>(java.io.InputStream&nbsp;in)</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#RecordInputStream-java.io.InputStream-org.apache.poi.poifs.crypt.EncryptionInfo-int-">RecordInputStream</a></span>(java.io.InputStream&nbsp;in,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                                       title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;key,
                                    int&nbsp;initialOffset)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t6" class="tableTab"><span><a
                                    href="javascript:show(32);">Deprecated Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#available--">available</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#getNextSid--">getNextSid</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#getSid--">getSid</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#hasNextRecord--">hasNextRecord</a></span>()</code>
                                    <div class="block">Note - this method is expected to be called only when completed
                                        reading the current BIFF
                                        record.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#mark-int-">mark</a></span>(int&nbsp;readlimit)</code>
                                    <div class="block">Mark the stream position - experimental function</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#nextRecord--">nextRecord</a></span>()</code>
                                    <div class="block">Moves to the next record in the stream.</div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#read-byte:A-int-int-">read</a></span>(byte[]&nbsp;b,
                                    int&nbsp;off,
                                    int&nbsp;len)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readAllContinuedRemainder--">readAllContinuedRemainder</a></span>()</code>
                                    <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;
                                        <div class="block"><span class="deprecationComment">POI 2.0 Best to write a input stream that wraps this one
             where there is special sub record that may overlap continue
             records.</span></div>
                                    </div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>byte</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readByte--">readByte</a></span>()</code>
                                    <div class="block">Reads an 8 bit, signed value</div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readCompressedUnicode-int-">readCompressedUnicode</a></span>(int&nbsp;requestedLength)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>double</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readDouble--">readDouble</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readFully-byte:A-">readFully</a></span>(byte[]&nbsp;buf)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readFully-byte:A-int-int-">readFully</a></span>(byte[]&nbsp;buf,
                                    int&nbsp;off,
                                    int&nbsp;len)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readFully-byte:A-int-int-boolean-">readFully</a></span>(byte[]&nbsp;buf,
                                    int&nbsp;off,
                                    int&nbsp;len,
                                    boolean&nbsp;isPlain)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readInt--">readInt</a></span>()</code>
                                    <div class="block">Reads a 32 bit, signed value</div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>long</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readLong--">readLong</a></span>()</code>
                                    <div class="block">Reads a 64 bit, signed value</div>
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readPlain-byte:A-int-int-">readPlain</a></span>(byte[]&nbsp;buf,
                                    int&nbsp;off,
                                    int&nbsp;len)</code>
                                    <div class="block">Usually acts the same as <a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readFully-byte:A-int-int-"><code>LittleEndianInput.readFully(byte[],
                                        int, int)</code></a>, but
                                        for an encrypted stream the raw (unencrypted) data is filled
                                    </div>
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readRemainder--">readRemainder</a></span>()</code>
                                    <div class="block">Returns the remaining bytes for the current record.</div>
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readShort--">readShort</a></span>()</code>
                                    <div class="block">Reads a 16 bit, signed value</div>
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readString--">readString</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i20" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readUByte--">readUByte</a></span>()</code>
                                    <div class="block">Reads an 8 bit, unsigned value</div>
                                </td>
                            </tr>
                            <tr id="i21" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readUnicodeLEString-int-">readUnicodeLEString</a></span>(int&nbsp;requestedLength)</code>
                                    <div class="block">given a byte array of 16-bit unicode characters, compress to
                                        8-bit and
                                        return a string

                                        { 0x16, 0x00 } -0x16
                                    </div>
                                </td>
                            </tr>
                            <tr id="i22" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#readUShort--">readUShort</a></span>()</code>
                                    <div class="block">Reads a 16 bit, unsigned value.</div>
                                </td>
                            </tr>
                            <tr id="i23" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#remaining--">remaining</a></span>()</code>
                                    <div class="block">The remaining number of bytes in the <i>current</i> record.</div>
                                </td>
                            </tr>
                            <tr id="i24" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#reset--">reset</a></span>()</code>
                                    <div class="block">Resets the stream position to the previously marked position.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="MAX_RECORD_DATA_SIZE">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>MAX_RECORD_DATA_SIZE</h4>
                                <pre>public static final&nbsp;short MAX_RECORD_DATA_SIZE</pre>
                                <div class="block">Maximum size of a single record (minus the 4 byte header) without a
                                    continue
                                </div>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.hssf.record.RecordInputStream.MAX_RECORD_DATA_SIZE">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="RecordInputStream-java.io.InputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>RecordInputStream</h4>
                                <pre>public&nbsp;RecordInputStream(java.io.InputStream&nbsp;in)
                  throws <a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                            title="class in org.apache.poi.util">RecordFormatException</a></pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                                                 title="class in org.apache.poi.util">RecordFormatException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="RecordInputStream-java.io.InputStream-org.apache.poi.poifs.crypt.EncryptionInfo-int-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>RecordInputStream</h4>
                                <pre>public&nbsp;RecordInputStream(java.io.InputStream&nbsp;in,
                         <a href="../../../../../org/apache/poi/poifs/crypt/EncryptionInfo.html"
                            title="class in org.apache.poi.poifs.crypt">EncryptionInfo</a>&nbsp;key,
                         int&nbsp;initialOffset)
                  throws <a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                            title="class in org.apache.poi.util">RecordFormatException</a></pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                                                 title="class in org.apache.poi.util">RecordFormatException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="available--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>available</h4>
                                <pre>public&nbsp;int&nbsp;available()</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#available--">available</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the number of bytes available in the current BIFF record</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../org/apache/poi/hssf/record/RecordInputStream.html#remaining--"><code>remaining()</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="read-byte:A-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>read</h4>
                                <pre>public&nbsp;int&nbsp;read(byte[]&nbsp;b,
                int&nbsp;off,
                int&nbsp;len)</pre>
                            </li>
                        </ul>
                        <a name="getSid--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSid</h4>
                                <pre>public&nbsp;short&nbsp;getSid()</pre>
                            </li>
                        </ul>
                        <a name="hasNextRecord--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>hasNextRecord</h4>
                                <pre>public&nbsp;boolean&nbsp;hasNextRecord()
                      throws <a href="../../../../../org/apache/poi/hssf/record/RecordInputStream.LeftoverDataException.html"
                                title="class in org.apache.poi.hssf.record">RecordInputStream.LeftoverDataException</a></pre>
                                <div class="block">Note - this method is expected to be called only when completed
                                    reading the current BIFF
                                    record.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true, if there's another record in the stream</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hssf/record/RecordInputStream.LeftoverDataException.html"
                                            title="class in org.apache.poi.hssf.record">RecordInputStream.LeftoverDataException</a></code>
                                        - if this method is called before reaching the end of the
                                        current record.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="nextRecord--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>nextRecord</h4>
                                <pre>public&nbsp;void&nbsp;nextRecord()
                throws <a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                          title="class in org.apache.poi.util">RecordFormatException</a></pre>
                                <div class="block">Moves to the next record in the stream.

                                    <i>Note: The auto continue flag is reset to true</i></div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a href="../../../../../org/apache/poi/util/RecordFormatException.html"
                                                 title="class in org.apache.poi.util">RecordFormatException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readByte--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readByte</h4>
                                <pre>public&nbsp;byte&nbsp;readByte()</pre>
                                <div class="block">Reads an 8 bit, signed value</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readByte--">readByte</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readShort--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readShort</h4>
                                <pre>public&nbsp;short&nbsp;readShort()</pre>
                                <div class="block">Reads a 16 bit, signed value</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readShort--">readShort</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readInt--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readInt</h4>
                                <pre>public&nbsp;int&nbsp;readInt()</pre>
                                <div class="block">Reads a 32 bit, signed value</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readInt--">readInt</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readLong--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readLong</h4>
                                <pre>public&nbsp;long&nbsp;readLong()</pre>
                                <div class="block">Reads a 64 bit, signed value</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readLong--">readLong</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readUByte--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readUByte</h4>
                                <pre>public&nbsp;int&nbsp;readUByte()</pre>
                                <div class="block">Reads an 8 bit, unsigned value</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readUByte--">readUByte</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readUShort--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readUShort</h4>
                                <pre>public&nbsp;int&nbsp;readUShort()</pre>
                                <div class="block">Reads a 16 bit, unsigned value.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readUShort--">readUShort</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readDouble--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readDouble</h4>
                                <pre>public&nbsp;double&nbsp;readDouble()</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readDouble--">readDouble</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readPlain-byte:A-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readPlain</h4>
                                <pre>public&nbsp;void&nbsp;readPlain(byte[]&nbsp;buf,
                      int&nbsp;off,
                      int&nbsp;len)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/util/LittleEndianInput.html#readPlain-byte:A-int-int-">LittleEndianInput</a></code></span>
                                </div>
                                <div class="block">Usually acts the same as <a
                                        href="../../../../../org/apache/poi/util/LittleEndianInput.html#readFully-byte:A-int-int-"><code>LittleEndianInput.readFully(byte[],
                                    int, int)</code></a>, but
                                    for an encrypted stream the raw (unencrypted) data is filled
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readPlain-byte:A-int-int-">readPlain</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>buf</code> - the byte array to receive the bytes</dd>
                                    <dd><code>off</code> - the start offset into the byte array</dd>
                                    <dd><code>len</code> - the amount of bytes to fill</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readFully-byte:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readFully</h4>
                                <pre>public&nbsp;void&nbsp;readFully(byte[]&nbsp;buf)</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readFully-byte:A-">readFully</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readFully-byte:A-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readFully</h4>
                                <pre>public&nbsp;void&nbsp;readFully(byte[]&nbsp;buf,
                      int&nbsp;off,
                      int&nbsp;len)</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/util/LittleEndianInput.html#readFully-byte:A-int-int-">readFully</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/util/LittleEndianInput.html"
                                                title="interface in org.apache.poi.util">LittleEndianInput</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readFully-byte:A-int-int-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readFully</h4>
                                <pre>protected&nbsp;void&nbsp;readFully(byte[]&nbsp;buf,
                         int&nbsp;off,
                         int&nbsp;len,
                         boolean&nbsp;isPlain)</pre>
                            </li>
                        </ul>
                        <a name="readString--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readString</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;readString()</pre>
                            </li>
                        </ul>
                        <a name="readUnicodeLEString-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readUnicodeLEString</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;readUnicodeLEString(int&nbsp;requestedLength)</pre>
                                <div class="block">given a byte array of 16-bit unicode characters, compress to 8-bit
                                    and
                                    return a string

                                    { 0x16, 0x00 } -0x16
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>requestedLength</code> - the length of the final string</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the converted string</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.IllegalArgumentException</code> - if len is too large (i.e.,
                                        there is not enough data in string to create a String of that
                                        length)
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readCompressedUnicode-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readCompressedUnicode</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;readCompressedUnicode(int&nbsp;requestedLength)</pre>
                            </li>
                        </ul>
                        <a name="readRemainder--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readRemainder</h4>
                                <pre>public&nbsp;byte[]&nbsp;readRemainder()</pre>
                                <div class="block">Returns the remaining bytes for the current record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The remaining bytes of the current record.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readAllContinuedRemainder--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readAllContinuedRemainder</h4>
                                <pre>@Deprecated
public&nbsp;byte[]&nbsp;readAllContinuedRemainder()</pre>
                                <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;<span
                                        class="deprecationComment">POI 2.0 Best to write a input stream that wraps this one
             where there is special sub record that may overlap continue
             records.</span></div>
                                <div class="block">Reads all byte data for the current record, including any that
                                    overlaps
                                    into any following continue records.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>all byte data for the current record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="remaining--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>remaining</h4>
                                <pre>public&nbsp;int&nbsp;remaining()</pre>
                                <div class="block">The remaining number of bytes in the <i>current</i> record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The number of bytes remaining in the current record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getNextSid--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getNextSid</h4>
                                <pre>public&nbsp;int&nbsp;getNextSid()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>sid of next record. Can be called after hasNextRecord()</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="mark-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>mark</h4>
                                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;void&nbsp;mark(int&nbsp;readlimit)</pre>
                                <div class="block">Mark the stream position - experimental function</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>readlimit</code> - the read ahead limit</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><code>InputStream.mark(int)</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="reset--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>reset</h4>
                                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;void&nbsp;reset()
                     throws java.io.IOException</pre>
                                <div class="block">Resets the stream position to the previously marked position.
                                    Experimental function - this only works, when nextRecord() wasn't called in the
                                    meantime.
                                </div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if marking is not supported</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><code>InputStream.reset()</code></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/RecordInputStream.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/hssf/record/RecordFactoryInputStream.html"
               title="class in org.apache.poi.hssf.record"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/hssf/record/RecordInputStream.LeftoverDataException.html"
               title="class in org.apache.poi.hssf.record"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/hssf/record/RecordInputStream.html"
               target="_top">Frames</a></li>
        <li><a href="RecordInputStream.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
